/////////////////////////////////////////////////////////////////////////////
//		BuLau.cpp
#include	<windows.h>
#include	<winuser.h>
#include	<shlobj.h>
#include	"resource.h"
#include	"util.h"


////////////////////////////////////////////////////////////
//	錾

//萔
#define	APPNAME		_T("BuLau")
#define	CLASSNAME	_T("BuLauClass")
#define	MAX_NAME	64
#define	BTN_SIZE	40
#define BtnItem(s)	( &g_BtnItem[(s)->x + (s)->y*g_BtnMax.x + (s)->p*g_BtnMax.x*g_BtnMax.y] )

//\
typedef struct
{
	TCHAR	szName[MAX_NAME];
	TCHAR	szIcon[MAX_PATH];
	TCHAR	szExec[MAX_PATH];
	TCHAR	szPara[MAX_NAME];
	TCHAR	szPath[MAX_PATH];
	UINT	nShow;
	HICON	hIcon;
} BTNITEM;

typedef struct
{
	LONG	p, x, y;
} BTNPOINT;

//ϐ
static	HINSTANCE	g_hInst;
static	TCHAR		g_szIniFile[MAX_PATH];

static	BTNITEM*	g_BtnItem;
static	BTNPOINT	g_BtnMax, g_BtnSel;


////////////////////////////////////////////////////////////
//	{^֌W

//\[Xǂݍ()
LPCTSTR GetString( UINT uID )
{
	static TCHAR	szBuff[128];

	if( LoadString( g_hInst, uID, szBuff, 128 ) )
		return	szBuff;
	else
		return	NULL;
}

//\[Xǂݍ(tB^[)
LPCTSTR GetFilter( UINT uID )
{
	LPTSTR	lpFilter	= (LPTSTR)GetString( uID );

	for( LPTCH lpCh = lpFilter; *lpCh; ++lpCh )
		if( *lpCh == '|' )	*lpCh = 0;

	return	lpFilter;
}

//\[Xǂݍ(R{{bNXݒ)
UINT CB_SetString( HWND hWnd, UINT uID )
{
	UINT	uRet		= 0;
	LPTSTR	lpFilter	= (LPTSTR)GetFilter( uID );

	for( LPTCH lpCh = lpFilter; *lpCh; ++lpCh )
	{
		SendMessage( hWnd, CB_ADDSTRING, 0, (LPARAM)lpCh );
		++uRet;

		while( *lpCh )
			++lpCh;
	}

	return	uRet;
}

//ACR擾
HICON GetIcon( LPTSTR pIcon )
{
	TCHAR	szIcon[MAX_PATH], *p;
	WORD	nIcon;

	if( pIcon[0] == 0 || pIcon[0] == _T(',') )
		return	NULL;

	lstrcpy( szIcon, pIcon );

	p		= lstrrchr( szIcon, _T(',') );
	if( p )	nIcon = (WORD)lston(p+1), *p = 0;
	else	nIcon = 0;

	return	ExtractAssociatedIcon( NULL, szIcon, &nIcon );
}
HICON GetIcon( LPTSTR szIcon, WORD nIcon )
{
	if( szIcon[0] == 0 )	return	NULL;

	return	ExtractAssociatedIcon( NULL, szIcon, &nIcon );
}

//f[^ۑ
BOOL SaveButton( BTNPOINT* pPt )
{
	TCHAR		szSec[MAX_NAME];

	BTNITEM*	pBtnItem = BtnItem( pPt );
	wsprintf( szSec, _T("%02d.%02d.%02d"), pPt->p, pPt->x, pPt->y );

	WritePrivateProfileString( szSec, _T("NAME"), pBtnItem->szName, g_szIniFile );
	WritePrivateProfileString( szSec, _T("ICON"), pBtnItem->szIcon, g_szIniFile );
	WritePrivateProfileString( szSec, _T("EXEC"), pBtnItem->szExec, g_szIniFile );
	WritePrivateProfileString( szSec, _T("PARA"), pBtnItem->szPara, g_szIniFile );
	WritePrivateProfileString( szSec, _T("PATH"), pBtnItem->szPath, g_szIniFile );
	WritePrivateProfileInt   ( szSec, _T("SHOW"), pBtnItem->nShow , g_szIniFile );

	return	TRUE;
}

//f[^Ǎ
BOOL LoadButton( BTNPOINT* pPt )
{
	TCHAR		szSec[MAX_NAME];

	BTNITEM*	pBtnItem = BtnItem( pPt );
	wsprintf( szSec, _T("%02d.%02d.%02d"), pPt->p, pPt->x, pPt->y );

	GetPrivateProfileString( szSec, _T("NAME"), _T(""), pBtnItem->szName, MAX_NAME, g_szIniFile );
	GetPrivateProfileString( szSec, _T("ICON"), _T(""), pBtnItem->szIcon, MAX_PATH, g_szIniFile );
	GetPrivateProfileString( szSec, _T("EXEC"), _T(""), pBtnItem->szExec, MAX_PATH, g_szIniFile );
	GetPrivateProfileString( szSec, _T("PARA"), _T(""), pBtnItem->szPara, MAX_NAME, g_szIniFile );
	GetPrivateProfileString( szSec, _T("PATH"), _T(""), pBtnItem->szPath, MAX_PATH, g_szIniFile );
	pBtnItem->nShow = GetPrivateProfileInt( szSec, _T("SHOW"), 0, g_szIniFile );
	pBtnItem->hIcon	= GetIcon( pBtnItem->szIcon );

	return	TRUE;
}

//`
BOOL DrawButton( BTNPOINT* pPt, HDC hDC, LONG nType )
{
	RECT		rc;
	BTNITEM*	pBtnItem = BtnItem( pPt );

	rc.left = pPt->x*BTN_SIZE;	rc.right  = rc.left + BTN_SIZE;
	rc.top  = pPt->y*BTN_SIZE;	rc.bottom = rc.top  + BTN_SIZE;

	if( nType == 0 )
		FillRect( hDC, &rc, GetSysColorBrush(COLOR_BTNFACE)   );
	else
		FillRect( hDC, &rc, GetSysColorBrush(COLOR_HIGHLIGHT) );

	if( nType <  2 ) {
		DrawEdge( hDC, &rc, EDGE_RAISED, BF_RECT );
		DrawIcon( hDC, rc.left+4,rc.top+4, pBtnItem->hIcon );
	}
	else {
		DrawEdge( hDC, &rc, EDGE_SUNKEN, BF_RECT );
		DrawIcon( hDC, rc.left+3,rc.top+3, pBtnItem->hIcon );
	}

	return	TRUE;
}

//s
BOOL ExecButton( BTNPOINT* pPt, LPCTSTR szPara=NULL )
{
	BTNITEM*			pBtnItem = BtnItem( pPt );
	SHELLEXECUTEINFO	sei;
	TCHAR				szBuff[1024];

	if( pBtnItem->szName[0] == 0 )
		return	FALSE;

	memset( &sei, 0, sizeof(SHELLEXECUTEINFO) );
	sei.cbSize			= sizeof(SHELLEXECUTEINFO);
	sei.lpFile			= pBtnItem->szExec;
	if( szPara == NULL )
		sei.lpParameters= pBtnItem->szPara;
	else {
		wsprintf( szBuff, _T("%s %s"), pBtnItem->szPara, szPara );
		sei.lpParameters= szBuff;
	}
	sei.lpDirectory		= pBtnItem->szPath;
	sei.nShow			= pBtnItem->nShow;

	ShellExecuteEx( &sei );

	return	TRUE;
}


////////////////////////////////////////////////////////////
//	{^̐ݒ_CAO

//ϐ
static	TCHAR		g_szIcon[MAX_PATH];
static	INT 		g_nIcon;

//R}hs
BOOL BtnCommand( HWND hDlg, WORD wCode, WORD wID, HWND hCtrl )
{
	switch( wID )
	{
	case IDOK:
		{
		BTNITEM*	pBtnItem = BtnItem( &g_BtnSel );

		SendDlgItemMessage( hDlg,IDC_BTNNAME, WM_GETTEXT, MAX_PATH, (LPARAM)pBtnItem->szName );
		SendDlgItemMessage( hDlg,IDC_BTNEXEC, WM_GETTEXT, MAX_PATH, (LPARAM)pBtnItem->szExec );
		SendDlgItemMessage( hDlg,IDC_BTNPARA, WM_GETTEXT, MAX_PATH, (LPARAM)pBtnItem->szPara );
		SendDlgItemMessage( hDlg,IDC_BTNPATH, WM_GETTEXT, MAX_PATH, (LPARAM)pBtnItem->szPath );

		wsprintf( pBtnItem->szIcon, _T("%s,%d"), g_szIcon, g_nIcon );
		pBtnItem->hIcon = GetIcon( g_szIcon, g_nIcon );

		pBtnItem->nShow = SendDlgItemMessage( hDlg, IDC_BTNSIZE, CB_GETCURSEL, 0, 0 ) + 1;

		SaveButton( &g_BtnSel );
		}
		EndDialog( hDlg, TRUE );
		return	TRUE;

	case IDCANCEL:
		EndDialog( hDlg, FALSE );
		return	TRUE;

	case IDNO:
		{
		memset( BtnItem(&g_BtnSel), 0, sizeof(BTNITEM) );

		TCHAR	szSec[MAX_NAME];
		wsprintf( szSec, _T("%02d.%02d.%02d"), g_BtnSel.p, g_BtnSel.x, g_BtnSel.y );
		DeletePrivateProfileSection( szSec, g_szIniFile );
		}
		EndDialog( hDlg, TRUE );
		return	TRUE;

	case IDC_BTNFILE:
		{
		TCHAR	szBuff[MAX_PATH];
		SendDlgItemMessage( hDlg,IDC_BTNEXEC, WM_GETTEXT, MAX_PATH, (LPARAM)szBuff );
		if( OpenDialogBox( szBuff, GetFilter(IDS_BTNFILE) ) )
		{
			TCHAR		*p;
			INT			nBuff;

			lstrcpy( g_szIcon, szBuff );	g_nIcon = 0;
			SendDlgItemMessage( hDlg,IDC_BTNICON, STM_SETICON, (WPARAM)GetIcon(g_szIcon,g_nIcon), 0 );

			p = lstrrchr(szBuff,_T('\\'))+1;	*lstrrchr(p,_T('.')) = 0;
			SendDlgItemMessage( hDlg,IDC_BTNNAME, WM_SETTEXT, 0, (LPARAM)p );

			lstrcpy( szBuff, g_szIcon );
			SendDlgItemMessage( hDlg,IDC_BTNEXEC, WM_SETTEXT, 0, (LPARAM)szBuff );

			lstrcpy( szBuff, _T("") );
			SendDlgItemMessage( hDlg,IDC_BTNPARA, WM_SETTEXT, 0, (LPARAM)szBuff );

			lstrcpy( szBuff, g_szIcon );	*lstrrchr(szBuff,_T('\\')) = 0;
			SendDlgItemMessage( hDlg,IDC_BTNPATH, WM_SETTEXT, 0, (LPARAM)szBuff );

			nBuff = SW_SHOWNORMAL;
			SendDlgItemMessage( hDlg, IDC_BTNSIZE, CB_SETCURSEL, --nBuff, 0 );
		}
		}
		return	TRUE;

	case IDC_BTNFOLD:
		{
		TCHAR	szBuff[MAX_PATH];
		SendDlgItemMessage( hDlg,IDC_BTNPATH, WM_GETTEXT, MAX_PATH, (LPARAM)szBuff );
		if( FolderDialogBox( szBuff, GetString(IDS_BTNPATH) ) )
			SendDlgItemMessage( hDlg,IDC_BTNPATH, WM_SETTEXT, 0, (LPARAM)szBuff );
		}
		return	TRUE;

	case IDC_BTNPICT:
		if( IconDialogBox( g_szIcon, &g_nIcon ) )
			SendDlgItemMessage( hDlg,IDC_BTNICON, STM_SETICON, (WPARAM)GetIcon(g_szIcon,g_nIcon), 0 );
		return	TRUE;
	}

	return	FALSE;
}

//t@Chbv
BOOL BtnDropFiles( HWND hDlg, HDROP hDrop )
{
	TCHAR		szBuff[MAX_PATH], *p;
	INT			nBuff;
	SHFILEINFO	sfi;

	DragQueryFile( hDrop, 0, szBuff, MAX_PATH );

	ZeroMemory( &sfi, sizeof(sfi) );
	SHGetFileInfo( szBuff, 0, &sfi, sizeof(sfi), SHGFI_ATTRIBUTES );
	if( sfi.dwAttributes != 0xFFFFFFFF )
	{
		if( sfi.dwAttributes & SFGAO_LINK )
		{
			IShellLink		*psl;
			IPersistFile	*ppf;

			CoInitialize( NULL );
			CoCreateInstance( CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (void **)&psl );
			psl->QueryInterface( IID_IPersistFile, (void **)&ppf );

#if UNICODE
			ppf->Load( szBuff, STGM_READ );
#else
			{
				WCHAR	szwBuff[MAX_PATH];
				MultiByteToWideChar( CP_ACP, 0, szBuff, -1, szwBuff, MAX_PATH );
				ppf->Load( szwBuff, STGM_READ );
			}
#endif

			p = lstrrchr(szBuff,_T('\\'))+1;	*lstrrchr(p,_T('.')) = 0;
			SendDlgItemMessage( hDlg,IDC_BTNNAME, WM_SETTEXT, 0, (LPARAM)p );

			psl->GetIconLocation( g_szIcon, MAX_PATH, &g_nIcon );
			if( g_szIcon[0] == NULL )	psl->GetPath( g_szIcon, MAX_PATH, NULL, 0 );
			SendDlgItemMessage( hDlg,IDC_BTNICON, STM_SETICON, (WPARAM)GetIcon(g_szIcon,g_nIcon), 0 );

			psl->GetPath( szBuff, MAX_PATH, NULL, 0 );
			SendDlgItemMessage( hDlg,IDC_BTNEXEC, WM_SETTEXT, 0, (LPARAM)szBuff );

			psl->GetArguments( szBuff, MAX_PATH );
			SendDlgItemMessage( hDlg,IDC_BTNPARA, WM_SETTEXT, 0, (LPARAM)szBuff );

			psl->GetWorkingDirectory( szBuff, MAX_PATH );
			SendDlgItemMessage( hDlg,IDC_BTNPATH, WM_SETTEXT, 0, (LPARAM)szBuff );

			psl->GetShowCmd( &nBuff );
			SendDlgItemMessage( hDlg, IDC_BTNSIZE, CB_SETCURSEL, --nBuff, 0 );

			ppf->Release();
			psl->Release();
			CoUninitialize();
		}
		else
		{
			lstrcpy( g_szIcon, szBuff );	g_nIcon = 0;
			SendDlgItemMessage( hDlg,IDC_BTNICON, STM_SETICON, (WPARAM)GetIcon(g_szIcon,g_nIcon), 0 );

			p = lstrrchr(szBuff,_T('\\'))+1;
			if( ~sfi.dwAttributes & SFGAO_FOLDER && lstrrchr(p,_T('.')) != NULL )
				*lstrrchr(p,_T('.')) = 0;
			SendDlgItemMessage( hDlg,IDC_BTNNAME, WM_SETTEXT, 0, (LPARAM)p );

			lstrcpy( szBuff, g_szIcon );
			SendDlgItemMessage( hDlg,IDC_BTNEXEC, WM_SETTEXT, 0, (LPARAM)szBuff );

			lstrcpy( szBuff, _T("") );
			SendDlgItemMessage( hDlg,IDC_BTNPARA, WM_SETTEXT, 0, (LPARAM)szBuff );

			if( ~sfi.dwAttributes & SFGAO_FOLDER ) {
				lstrcpy( szBuff, g_szIcon );	*lstrrchr(szBuff,_T('\\')) = 0;
			}
			SendDlgItemMessage( hDlg,IDC_BTNPATH, WM_SETTEXT, 0, (LPARAM)szBuff );

			nBuff = SW_SHOWNORMAL;
			SendDlgItemMessage( hDlg, IDC_BTNSIZE, CB_SETCURSEL, --nBuff, 0 );
		}
	}

	DragFinish( hDrop );

	return	TRUE;
}

//vV[W
BOOL CALLBACK BtnDlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
	case WM_INITDIALOG:
		{
		BTNITEM*	pBtnItem = BtnItem( &g_BtnSel );

		SendDlgItemMessage( hDlg,IDC_BTNNAME, WM_SETTEXT, 0, (LPARAM)pBtnItem->szName );
		SendDlgItemMessage( hDlg,IDC_BTNEXEC, WM_SETTEXT, 0, (LPARAM)pBtnItem->szExec );
		SendDlgItemMessage( hDlg,IDC_BTNPARA, WM_SETTEXT, 0, (LPARAM)pBtnItem->szPara );
		SendDlgItemMessage( hDlg,IDC_BTNPATH, WM_SETTEXT, 0, (LPARAM)pBtnItem->szPath );

		SendDlgItemMessage( hDlg,IDC_BTNICON, STM_SETICON, (WPARAM)pBtnItem->hIcon, 0 );

		CB_SetString( GetDlgItem(hDlg,IDC_BTNSIZE), IDS_BTNSIZE);
		SendDlgItemMessage( hDlg,IDC_BTNSIZE, CB_SETCURSEL, pBtnItem->nShow-1, 0 );

		lstrcpy( g_szIcon, pBtnItem->szIcon );
		TCHAR	*p = lstrrchr( g_szIcon, ',' );
		if( p )	g_nIcon = (WORD)lston(p+1), *p = 0;
		else	g_nIcon = 0;
		}
		return	TRUE;

	case WM_COMMAND:
		return	BtnCommand( hDlg, HIWORD(wParam), LOWORD(wParam), (HWND)lParam );

	case	WM_DROPFILES:
		return	BtnDropFiles( hDlg, (HDROP)wParam );
	}

	return	FALSE;
}


////////////////////////////////////////////////////////////
//	IvV_CAO

//ϐ
static	UINT		g_HidWnd;
static	UINT		g_ActMou;
static	UINT		g_HotKey;

//vV[W
BOOL CALLBACK OptDlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
	case WM_INITDIALOG:
		CB_SetString( GetDlgItem(hDlg,IDC_OPTHIDE), IDS_OPTHIDE);
		SendDlgItemMessage( hDlg,IDC_OPTHIDE, CB_SETCURSEL, g_HidWnd, 0 );

		CB_SetString( GetDlgItem(hDlg,IDC_OPTMOUS), IDS_OPTMOUS);
		SendDlgItemMessage( hDlg,IDC_OPTMOUS, CB_SETCURSEL, g_ActMou, 0 );

		SendDlgItemMessage( hDlg,IDC_OPTPAGESPN, UDM_SETPOS, 0, g_BtnMax.p );
		SendDlgItemMessage( hDlg,IDC_OPTBTNXSPN, UDM_SETPOS, 0, g_BtnMax.x );
		SendDlgItemMessage( hDlg,IDC_OPTBTNYSPN, UDM_SETPOS, 0, g_BtnMax.y );
		SendDlgItemMessage( hDlg,IDC_OPTHKEY, HKM_SETHOTKEY, g_HotKey, 0 );
		return	TRUE;

	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDOK:
			g_BtnMax.p	= SendDlgItemMessage( hDlg,IDC_OPTPAGESPN, UDM_GETPOS, 0, 0 );
			g_BtnMax.x	= SendDlgItemMessage( hDlg,IDC_OPTBTNXSPN, UDM_GETPOS, 0, 0 );
			g_BtnMax.y	= SendDlgItemMessage( hDlg,IDC_OPTBTNYSPN, UDM_GETPOS, 0, 0 );
			g_HidWnd	= SendDlgItemMessage( hDlg,IDC_OPTHIDE, CB_GETCURSEL , 0, 0 );
			g_ActMou	= SendDlgItemMessage( hDlg,IDC_OPTMOUS, CB_GETCURSEL , 0, 0 );
			g_HotKey	= SendDlgItemMessage( hDlg,IDC_OPTHKEY, HKM_GETHOTKEY, 0, 0 );

			WritePrivateProfileInt( _T("option"), _T("widht") , g_BtnMax.x, g_szIniFile );
			WritePrivateProfileInt( _T("option"), _T("height"), g_BtnMax.y, g_szIniFile );
			WritePrivateProfileInt( _T("option"), _T("pages") , g_BtnMax.p, g_szIniFile );
			WritePrivateProfileInt( _T("option"), _T("hide")  , g_HidWnd  , g_szIniFile );
			WritePrivateProfileInt( _T("option"), _T("mouse") , g_ActMou  , g_szIniFile );
			WritePrivateProfileInt( _T("option"), _T("hotkey"), g_HotKey  , g_szIniFile );

			EndDialog( hDlg, TRUE );
			return	TRUE;

		case IDCANCEL:
			EndDialog( hDlg, FALSE );
			return	TRUE;
		}
	}

	return	FALSE;
}


////////////////////////////////////////////////////////////
//	pl

//ϐ
static	BOOL		g_BtnDown;
static	RECT		g_Rect;

///I
BOOL OnInitDialog( HWND hDlg, HWND hwndFocus, LPARAM lInitParam )
{
	UINT		nMod	= 0;
	RECT		rc;
	BTNPOINT	pt;

	if( lInitParam )
	{
		HMENU		hMenu = GetSystemMenu(hDlg,FALSE);
		AppendMenu( hMenu, MF_SEPARATOR, -1, NULL );
		AppendMenu( hMenu, MF_STRING, 1, GetString(IDS_MENUSET) );

		g_Rect.left	= GetPrivateProfileInt( _T("option"),_T("left")  , 0, g_szIniFile );
		g_Rect.top	= GetPrivateProfileInt( _T("option"),_T("top")   , 0, g_szIniFile );
		g_BtnMax.x	= GetPrivateProfileInt( _T("option"),_T("widht") , 4, g_szIniFile );
		g_BtnMax.y	= GetPrivateProfileInt( _T("option"),_T("height"), 2, g_szIniFile );
		g_BtnMax.p	= GetPrivateProfileInt( _T("option"),_T("pages") , 2, g_szIniFile );
		g_HidWnd	= GetPrivateProfileInt( _T("option"),_T("hide")  , 0, g_szIniFile );
		g_ActMou	= GetPrivateProfileInt( _T("option"),_T("mouse") , 0, g_szIniFile );
		g_HotKey	= GetPrivateProfileInt( _T("option"),_T("hotkey"), 0, g_szIniFile );
		g_BtnSel.p	= 0;
		g_BtnSel.x	= 0;
		g_BtnSel.y	= 0;
		g_BtnDown	= FALSE;
	}
	else
		delete g_BtnItem;

	rc.left			= 0;
	rc.top			= 0;
	rc.right		= g_BtnMax.x * BTN_SIZE;
	rc.bottom		= g_BtnMax.y * BTN_SIZE;
	AdjustWindowRectEx( &rc, DS_MODALFRAME|WS_POPUP|WS_CAPTION|WS_SYSMENU, FALSE, WS_EX_TOOLWINDOW );
	g_Rect.right	= rc.right  - rc.left;
	g_Rect.bottom	= rc.bottom - rc.top;

	g_BtnItem		= new BTNITEM[g_BtnMax.x*g_BtnMax.y*g_BtnMax.p];
	for( pt.p=0; pt.p<g_BtnMax.p; ++pt.p )
	for( pt.y=0; pt.y<g_BtnMax.y; ++pt.y )
	for( pt.x=0; pt.x<g_BtnMax.x; ++pt.x )
		LoadButton( &pt );

	if( HIBYTE(g_HotKey) & HOTKEYF_ALT     )	nMod |= MOD_ALT;
	if( HIBYTE(g_HotKey) & HOTKEYF_CONTROL )	nMod |= MOD_CONTROL;
	if( HIBYTE(g_HotKey) & HOTKEYF_SHIFT   )	nMod |= MOD_SHIFT;
	RegisterHotKey( hDlg, 0, nMod, LOBYTE(g_HotKey) );

	return	0;
}
BOOL OnClose( HWND hDlg )
{
	WritePrivateProfileInt( _T("option"),_T("left"), g_Rect.left, g_szIniFile );
	WritePrivateProfileInt( _T("option"),_T("top") , g_Rect.top , g_szIniFile );

	UnregisterHotKey( hDlg, 0 );

	DestroyWindow( hDlg );

	delete g_BtnItem;

	return	0;
}

//`
BOOL OnPaint( HWND hDlg )
{
	HDC			hDc, hMemDc;
	HBITMAP		hMemBmp;
	PAINTSTRUCT	ps;
	BTNPOINT	pt;

	if( IsWindowForeground(hDlg) && BtnItem(&g_BtnSel)->szName[0] )
		SetWindowText( hDlg, BtnItem(&g_BtnSel)->szName );
	else
		SetWindowText( hDlg, APPNAME );

	hDc		= BeginPaint( hDlg, &ps );
	hMemDc	= CreateCompatibleDC( hDc );
	hMemBmp	= CreateCompatibleBitmap( hDc, g_BtnMax.x*BTN_SIZE, g_BtnMax.y*BTN_SIZE );
	SelectObject( hMemDc, hMemBmp );

	pt.p = g_BtnSel.p;
	for( pt.y=0; pt.y<g_BtnMax.y; ++pt.y )
	for( pt.x=0; pt.x<g_BtnMax.x; ++pt.x )
	{
		if( pt.x != g_BtnSel.x || pt.y != g_BtnSel.y || ! IsWindowForeground(hDlg) )
			DrawButton( &pt, hMemDc, 0 );
		else if( ! g_BtnDown )
			DrawButton( &pt, hMemDc, 1 );
		else
			DrawButton( &pt, hMemDc, 2 );
	}

	BitBlt( hDc, 0,0,g_BtnMax.x*BTN_SIZE,g_BtnMax.y*BTN_SIZE, hMemDc, 0,0, SRCCOPY );

	DeleteObject( hMemBmp );
	DeleteDC( hMemDc );
	EndPaint( hDlg, &ps );

	return	0;
}

//t@Chbv
BOOL OnDropFiles( HWND hDlg, HDROP hDrop )
{
	TCHAR		szBuff[MAX_PATH];
	INT			i, m;
	POINT		pt;

	DragQueryPoint( hDrop, &pt );
	g_BtnSel.x = pt.x / BTN_SIZE;	if( g_BtnSel.x < 0 || g_BtnMax.x <= g_BtnSel.x )	return	-1;
	g_BtnSel.y = pt.y / BTN_SIZE;	if( g_BtnSel.y < 0 || g_BtnMax.y <= g_BtnSel.y )	return	-1;

	if( BtnItem(&g_BtnSel)->szExec[0] )
	{
		m = DragQueryFile( hDrop, -1, szBuff, MAX_PATH );
		for( i=0; i<m; ++i )
		{
			DragQueryFile( hDrop, i, szBuff, MAX_PATH );
			ExecButton( &g_BtnSel, szBuff );
		}
	}

	DragFinish( hDrop );

	return	0;
}

//[ɉB
BOOL OnActiveApp( HWND hDlg, BOOL fActive, DWORD dwThreadID )
{
	RECT	rc, rcTop;
	SystemParametersInfo( SPI_GETWORKAREA, 0, &rcTop, 0 );

	if( g_HidWnd == 1 )	g_Rect.left = rcTop.left;
	if( g_HidWnd == 2 )	g_Rect.left = rcTop.right - g_Rect.right;
	if( g_HidWnd == 3 )	g_Rect.top  = rcTop.top;
	if( g_HidWnd == 4 )	g_Rect.top  = rcTop.bottom - g_Rect.bottom;
	rc = g_Rect;

	if( ! fActive )
	{
		if( g_HidWnd == 1 )											rc.right  = 1;
		if( g_HidWnd == 2 )	rc.left   = rc.left + rc.right  - 1,	rc.right  = 1;
		if( g_HidWnd == 3 )											rc.bottom = 1;
		if( g_HidWnd == 4 )	rc.top    = rc.top  + rc.bottom - 1,	rc.bottom = 1;

		g_BtnDown = FALSE;
	}

	if( g_HidWnd || fActive )
		SetWindowPos( hDlg, HWND_TOPMOST, rc.left, rc.top, rc.right, rc.bottom, SWP_NOACTIVATE );
	else
		SetWindowPos( hDlg, HWND_NOTOPMOST, rc.left, rc.top, rc.right, rc.bottom, SWP_NOACTIVATE );

	RedrawWindow( hDlg, NULL, NULL, RDW_INVALIDATE|RDW_UPDATENOW );

	return	0;
}

//L[
BOOL OnKeyDown( HWND hDlg, UINT vk, int cRepeat, UINT flags )
{
	switch( vk )
	{
	case	VK_RETURN:
	case	VK_SPACE:
		g_BtnDown = TRUE;
		break;

	default:
		return	-1;
	}

	RedrawWindow( hDlg, NULL, NULL, RDW_INVALIDATE|RDW_UPDATENOW );

	return	0;
}
BOOL OnKeyUp( HWND hDlg, UINT vk, int cRepeat, UINT flags )
{
	switch( vk )
	{
	case	VK_RETURN:
	case	VK_SPACE:
		if( g_BtnDown ) {
			g_BtnDown	= FALSE;
			ExecButton( &g_BtnSel );
		}
		break;

	case	VK_APPS:
		if( DialogBox( g_hInst, MAKEINTRESOURCE(IDD_DLGBTN), hDlg, (DLGPROC)BtnDlgProc ) )
		{
			LoadButton( &g_BtnSel );
			RedrawWindow( hDlg, NULL, NULL, RDW_INVALIDATE|RDW_UPDATENOW );
		}
		break;

	case	VK_PRIOR:
		if( --g_BtnSel.p <  0          )	g_BtnSel.p = g_BtnMax.p - 1;
		break;
	case	VK_NEXT:
		if( ++g_BtnSel.p >= g_BtnMax.p )	g_BtnSel.p = 0;
		break;

	case	VK_LEFT:
		if( g_BtnSel.x < 0 )	g_BtnSel.x = g_BtnMax.x-1,	g_BtnSel.y = 0;
		else					g_BtnSel.x--;
		break;
	case	VK_RIGHT:
		if( g_BtnSel.x < 0 )	g_BtnSel.x = 0,				g_BtnSel.y = 0;
		else					g_BtnSel.x++;
		break;
	case	VK_UP:
		if( g_BtnSel.y < 0 )	g_BtnSel.y = g_BtnMax.y-1,	g_BtnSel.x = 0;
		else					g_BtnSel.y--;
		break;
	case	VK_DOWN:
		if( g_BtnSel.y < 0 )	g_BtnSel.y = 0,				g_BtnSel.x = 0;
		else					g_BtnSel.y++;
		break;

	default:
		return	-1;
	}

	if( g_BtnSel.x <  0          )	g_BtnSel.x = g_BtnMax.x-1;
	if( g_BtnSel.x >= g_BtnMax.x )	g_BtnSel.x = 0;
	if( g_BtnSel.y <  0          )	g_BtnSel.y = g_BtnMax.y-1;
	if( g_BtnSel.y >= g_BtnMax.y )	g_BtnSel.y = 0;

	RedrawWindow( hDlg, NULL, NULL, RDW_INVALIDATE|RDW_UPDATENOW );

	return	0;
}

//vV[W
BOOL CALLBACK DialogProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
	case	WM_INITDIALOG:
		return	OnInitDialog( hDlg, (HWND)wParam, lParam );
	case	WM_CLOSE:
		return	OnClose( hDlg );
	case	WM_DESTROY:
		PostQuitMessage( 0 );
		return	0;

	case	WM_PAINT:
		return	OnPaint( hDlg );
	case	WM_DROPFILES:
		return	OnDropFiles( hDlg, (HDROP)wParam );

	case	WM_MOVE:
		if( IsWindowForeground(hDlg) ) {
			RECT	rc;
			GetWindowRect( hDlg, &rc );
			g_Rect.left = rc.left;
			g_Rect.top  = rc.top;
		}
		return	0;

	case	WM_ACTIVATEAPP:
		return	OnActiveApp( hDlg, (BOOL)wParam, (DWORD)lParam );

	case WM_HOTKEY:
		SetForegroundWindowEx( hDlg );
		return	0;

	case	WM_NCMOUSEMOVE:
		if( g_ActMou && ! IsWindowForeground(hDlg) )
			SetForegroundWindowEx( hDlg );
		return	0;

	case	WM_MOUSEMOVE:
		if( g_ActMou && ! IsWindowForeground(hDlg) )
			SetForegroundWindowEx( hDlg );
		if( g_BtnSel.x != LOWORD(lParam)/BTN_SIZE || g_BtnSel.y != HIWORD(lParam)/BTN_SIZE )
		{
			g_BtnSel.x = LOWORD(lParam)/BTN_SIZE;
			g_BtnSel.y = HIWORD(lParam)/BTN_SIZE;
			RedrawWindow( hDlg, NULL, NULL, RDW_INVALIDATE|RDW_UPDATENOW );
		}
		return	0;
	case	WM_RBUTTONUP:
		if( DialogBox( g_hInst, MAKEINTRESOURCE(IDD_DLGBTN), hDlg, (DLGPROC)BtnDlgProc ) )
		{
			LoadButton( &g_BtnSel );
			RedrawWindow( hDlg, NULL, NULL, RDW_INVALIDATE|RDW_UPDATENOW );
		}
		return	0;
	case	WM_LBUTTONDOWN:
		return	OnKeyDown( hDlg, VK_SPACE, 0, 0 );
	case	WM_LBUTTONUP:
		return	OnKeyUp( hDlg, VK_SPACE, 0, 0 );
	case	WM_MOUSEWHEEL:
		return	OnKeyUp( hDlg, (short)HIWORD(wParam)>0 ? VK_PRIOR : VK_NEXT, 0, 0 );

	case	WM_KEYDOWN:
		return	OnKeyDown( hDlg, wParam, LOWORD(lParam), HIWORD(lParam) );
	case	WM_KEYUP:
		return	OnKeyUp( hDlg, wParam, LOWORD(lParam), HIWORD(lParam) );

	case WM_GETDLGCODE:
		return	DLGC_WANTALLKEYS;

	case WM_SYSCOMMAND:
		if( wParam == 1 )
		{
			if( DialogBox( g_hInst, MAKEINTRESOURCE(IDD_DLGOPT), hDlg, (DLGPROC)OptDlgProc ) )
			{
				OnInitDialog( hDlg, NULL, 0 );
				OnActiveApp( hDlg, TRUE, 0 );
			}
			return	0;
		}
		break;
	}

	return	DefWindowProc( hDlg, uMsg, wParam, lParam );
}


////////////////////////////////////////////////////////////
//	C֐

//C
int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow )
{
	HWND		hDlg;
	MSG			msg;
	WNDCLASS	wc;

	hDlg = FindWindow( CLASSNAME, NULL );
	if( hDlg ) {
		SetForegroundWindow( hDlg );
		return	TRUE;
	}

	g_hInst = hInst;

	GetModuleFileName( g_hInst, g_szIniFile, MAX_PATH );
	lstrcpy( lstrrchr(g_szIniFile,_T('.')), _T(".ini") );

	wc.style		= 0;
	wc.lpfnWndProc	= (WNDPROC)DialogProc;
	wc.cbClsExtra	= 0;
	wc.cbWndExtra	= DLGWINDOWEXTRA;
	wc.hInstance	= hInst;
	wc.hIcon		= LoadIcon( hInst, MAKEINTRESOURCE(IDI_MAIN) );
	wc.hCursor		= LoadCursor( NULL, IDC_ARROW );
	wc.hbrBackground= (HBRUSH)(COLOR_BTNFACE+1);
	wc.lpszMenuName	= NULL;
	wc.lpszClassName= CLASSNAME;
	if( RegisterClass(&wc) == 0 )
		return	FALSE;

	hDlg = CreateDialogParam( hInst, MAKEINTRESOURCE(IDD_DLGMAIN), 0, (DLGPROC)DialogProc, -1 );
	if( hDlg == NULL )
		return	FALSE;

	SetWindowPos( hDlg, NULL, 0,0,0,0, SWP_NOMOVE|SWP_NOSIZE|SWP_SHOWWINDOW );
	UpdateWindow( hDlg );

	while( GetMessage(&msg, NULL, 0, 0) )
	{
		if( IsDialogMessage(hDlg,&msg) == FALSE )
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}
	return	msg.wParam;
}
//
extern "C"
void __cdecl WinMainCRTStartup( void )
{
	ExitProcess( WinMain( GetModuleHandle(NULL), NULL, NULL, SW_SHOWDEFAULT ) );
}
void* operator new(size_t size){return GlobalAlloc(GPTR,size);}
void operator delete(void* ptr){GlobalFree((HGLOBAL)ptr);}
