/////////////////////////////////////////////////////////////////////////////
//		util.c / util.cpp

#include	<windows.h>
#include	<shlobj.h>
#include	<psapi.h>
#include	<tlhelp32.h>
#include	"util.h"

#pragma		comment(lib, "psapi.lib")


#ifdef __cplusplus
extern "C" {
#endif


//////////////////////////////////////////////////////////
//	f[^ϊ

INT lston( LPCTSTR lpStr )
{
	LPTCH	p=(LPTSTR)lpStr;
	INT	s=1, n=0;
	if( *p == _T('-') )	s = -1, ++p;
	while( _T('0') <= *p && *p <= _T('9') )
	{
		n = n*10 + ( *p - _T('0') );
		++p;
	}
	return( s * n );
}
LPTSTR lntos( INT nNum, LPTSTR lpBuf )
{
	LPTCH	p=lpBuf;
	INT	n;
	if( nNum < 0 )	*p = _T('-'), ++p;
	n = nNum;
	do {
		++p;
		n /= 10;
	} while( n );
	*p = 0;
	n = ( nNum<0 ? -nNum : nNum );
	do {
		--p;
		*p = n %10 + _T('0');
		n /= 10;
	} while( n );
	return( lpBuf );
}


//////////////////////////////////////////////////////////
//	񑀍

LPTSTR lstrchr( LPCTSTR lpStr, TCHAR ch )
{
	LPTCH	p;
	for( p=(LPTCH)lpStr; *p && *p!=ch; ++p );
	return( *p ? p : NULL );
}

LPTSTR lstrrchr( LPCTSTR lpStr, TCHAR ch )
{
	LPTCH	p, q=NULL;
	for( p=(LPTCH)lpStr; *p; ++p )
		if( *p == ch )	q = p;
	return q;
}

LPTSTR lstrstr( LPCTSTR lpStr1, LPCTSTR lpStr2 )
{
	LPTCH	r, p, q;

	for( r=(LPTCH)lpStr1; *r; ++r )
	{
		for( p=r,q=(LPTCH)lpStr2; *p && *q; ++p,++q )
			if( *p != *q )	break;
		if( *q == 0 )
			return r;
	}

	return 0;
}

LPTSTR lstrstri( LPCTSTR lpStr1, LPCTSTR lpStr2 )
{
	LPTCH	r, p, q;

	for( r=(LPTCH)lpStr1; *r; ++r )
	{
		for( p=r,q=(LPTCH)lpStr2; *p && *q; ++p,++q )
			if( (*p|0x20) != (*q|0x20) )	break;
		if( *q == 0 )
			return r;
	}

	return 0;
}

LPTSTR lstrend( LPCTSTR lpStr )
{
	LPTCH	p=(LPTCH)lpStr;
	for( ; *p; ++p );
	return p;
}

INT lstrcmpn( LPCTSTR lpStr1, LPCTSTR lpStr2, INT nMax )
{
	INT		n=0;
	LPTCH	p=(LPTCH)lpStr1, q=(LPTCH)lpStr2;
	for( ; *p && *q && *p==*q && n<nMax; ++p,++q,++n )
		;
	if( *p==*q || n>=nMax )	return 0;
	return( *p<*q ? -1 : 1 );
}

INT lstrchk( LPCTSTR lpStr1, LPCTSTR lpStr2 )
{
	LPTCH	p=(LPTCH)lpStr1, q=(LPTCH)lpStr2;
	for( ; ; ++p, ++q )
	{
		if( *p == _T('*') ) {
			++p;
			do {
				if( ! lstrchk(p,q) )	return	0;
			} while( *q++ );
			return	1;
		}
		if( *q == _T('*') ) {
			++q;
			do {
				if ( ! lstrchk(p,q) )	return	0;
			} while( *p++ );
			return	-1;
		}
		if( *p == _T('\0') && *q == _T('\0') ) return	0;
		if( *p == _T('\0') || *q == _T('\0') ) return	*p>*q ? 1 : -1;
		if( *p != _T('?' ) && *q != _T('?' ) && *p != *q )	return *p>*q ? 1 : -1;
	}
}

INT lstrchki( LPCTSTR lpStr1, LPCTSTR lpStr2 )
{
	LPTCH	p=(LPTCH)lpStr1, q=(LPTCH)lpStr2;
	for( ; ; ++p, ++q )
	{
		if( *p == _T('*') ) {
			++p;
			do {
				if( ! lstrchki(p,q) )	return	0;
			} while( *q++ );
			return	1;
		}
		if( *q == _T('*') ) {
			++q;
			do {
				if ( ! lstrchki(p,q) )	return	0;
			} while( *p++ );
			return	-1;
		}
		if( *p == _T('\0') && *q == _T('\0') ) return	0;
		if( *p == _T('\0') || *q == _T('\0') ) return	(*p|0x20)>(*q|0x20) ? 1 : -1;
		if( *p != _T('?' ) && *q != _T('?' ) && (*p|0x20) != (*q|0x20) )	return (*p|0x20)>(*q|0x20) ? 1 : -1;
	}
}

INT IsLegal( LPCTSTR lpStr )
{
#if UNICODE
	return	FALSE;
#else
	BYTE	u = *lpStr, v = *(lpStr+1);

	return ( ((0x81<=u && u<=0x9F) || (0xE0<=u && u<=0xFC))
		  && ((0x40<=v && v<=0x7E) || (0x80<=v && v<=0xFC)) );
#endif
}


//////////////////////////////////////////////////////////
//	ݒt@C

//̏
BOOL WritePrivateProfileInt( LPCTSTR szSection, LPCTSTR szKey, INT nValue, LPCTSTR szFile )
{
	TCHAR	szBuf[16];
	return	WritePrivateProfileString( szSection, szKey, lntos(nValue,szBuf), szFile );
}


//////////////////////////////////////////////////////////
//	WXg

//L[J
HKEY RegKeyOpen( HKEY hRootKey, LPCTSTR szSubKey )
{
	HKEY	hSubKey;

	if( RegOpenKeyEx( hRootKey, szSubKey, 0, KEY_READ, &hSubKey ) == ERROR_SUCCESS )
		return	hSubKey;
	else
		return	NULL;
}

//L[쐬
HKEY RegKeyCreate( HKEY hRootKey, LPCTSTR szSubKey )
{
	HKEY	hSubKey;
	DWORD	dwDispos;

	if( RegCreateKeyEx( hRootKey, szSubKey, 0, _T(""), REG_OPTION_NON_VOLATILE,
						KEY_WRITE, NULL, &hSubKey, &dwDispos ) == ERROR_SUCCESS )
		return	hSubKey;
	else
		return	NULL;
}

//L[
VOID RegKeyClose( HKEY hSubKey )
{
	RegCloseKey( hSubKey );
}

//L[폜
BOOL RegKeyDelete( HKEY hRootKey, LPCTSTR szSubKey )
{
	HKEY	hSubKey;
	DWORD	dwSubKey;

	//L[݂
	hSubKey = RegKeyOpen( hRootKey, szSubKey );
	if( hSubKey )
	{
		//TuL[͂Ȃ
		RegQueryInfoKey( hSubKey, NULL, NULL, NULL, &dwSubKey,
							NULL, NULL, NULL, NULL, NULL, NULL, NULL );
		RegKeyClose( hSubKey );
		if( dwSubKey == 0 )
			RegDeleteKey( hRootKey, szSubKey );
		else
			return	FALSE;
	}

	return	TRUE;
}
BOOL RegKeyForceDelete( HKEY hRootKey, LPCTSTR szSubKey )
{
	HKEY		hSubKey;
	DWORD		dwSize;
	TCHAR		szBuff[MAX_PATH];

	//L[݂
	hSubKey = RegKeyOpen( hRootKey, szSubKey );
	if( hSubKey )
	{
		//TuL[폜
		dwSize = MAX_PATH;
		while( RegEnumKeyEx(hSubKey,0,szBuff,&dwSize,NULL,NULL,NULL,NULL) == ERROR_SUCCESS )
			RegKeyForceDelete( hSubKey, szBuff );

		RegKeyClose( hSubKey );
		RegDeleteKey( hRootKey, szSubKey );
	}

	return	TRUE;
}

//l̎擾
DWORD RegGetNumber( HKEY hKey, LPCTSTR szEntry )
{
	DWORD	dwType, dwValue, dwSize;

	dwValue = 0;
	dwSize  = sizeof(DWORD);

	RegQueryValueEx( hKey, szEntry, NULL, &dwType, (LPBYTE)&dwValue, &dwSize );

	if( dwType == REG_DWORD )
		return	dwValue;
	else
		return	0;
}

//l̐ݒ
VOID RegSetNumber( HKEY hKey, LPCTSTR szEntry, DWORD dwValue )
{
	RegSetValueEx( hKey, szEntry, 0, REG_DWORD, (BYTE *)&dwValue, sizeof(DWORD) );
}

//̎擾
DWORD RegGetString( HKEY hKey, LPCTSTR szEntry, LPTSTR szBuffer, DWORD dwSize )
{
	DWORD	dwType;

	ZeroMemory( szBuffer, dwSize );

	RegQueryValueEx( hKey, szEntry, 0, &dwType, (LPBYTE)szBuffer, &dwSize );

	if( dwType == REG_SZ )
		return	dwSize;
	else
		return	0;
}

//̐ݒ
VOID RegSetString( HKEY hKey, LPCTSTR szEntry, LPCTSTR szValue )
{
	RegSetValueEx( hKey, szEntry, 0, REG_SZ, (BYTE *)szValue, lstrlen(szValue)*sizeof(TCHAR) );
}

//oCi̎擾
DWORD RegGetBinary( HKEY hKey, LPCTSTR szEntry, LPVOID lpBuffer, DWORD dwSize )
{
	DWORD	dwType;

	ZeroMemory( lpBuffer, dwSize );

	RegQueryValueEx( hKey, szEntry, 0, &dwType, (LPBYTE)lpBuffer, &dwSize );

	if( dwType == REG_BINARY )
		return	dwSize;
	else
		return	0;
}

//oCi̐ݒ
VOID RegSetBinary( HKEY hKey, LPCTSTR szEntry, LPVOID lpBuffer, DWORD dwSize )
{
	RegSetValueEx( hKey, szEntry, 0, REG_BINARY, (BYTE *)lpBuffer, dwSize );
}

//l̍폜
VOID RegDelValue( HKEY hKey, LPCTSTR szEntry )
{
	RegDeleteValue( hKey, szEntry );
}


//////////////////////////////////////////////////////////
//	EBhE

//EBhEtHAOEhɂ
BOOL SetForegroundWindowEx( HWND hWnd )
{
	BOOL	bRet;
	int		nTargetID, nCurrentID;

	nCurrentID = GetWindowThreadProcessId( hWnd, NULL );
	nTargetID  = GetWindowThreadProcessId( GetForegroundWindow(), NULL );

	AttachThreadInput( nTargetID, nCurrentID, TRUE );
	bRet = SetForegroundWindow( hWnd );
	AttachThreadInput( nTargetID, nCurrentID, FALSE );

	return	bRet;
}

//EBhẼW[擾
BOOL GetWindowBaseName( HWND hWnd, LPTSTR szBaseName, DWORD dwBaseSize )
{
	DWORD			dwProcessId;
	DWORD			dwReturn;
	HANDLE			hProcess;
	HMODULE			hModule;

	//EBhẼvZXID
	GetWindowThreadProcessId( hWnd , &dwProcessId );

	//vZXƃW[ƃt@C̎擾
	hProcess = OpenProcess( PROCESS_QUERY_INFORMATION|PROCESS_VM_READ, FALSE, dwProcessId );
	if( ! hProcess ) {
		return	FALSE;
	}

	if( ! EnumProcessModules( hProcess, &hModule, sizeof(hModule), &dwReturn ) ) {
		CloseHandle( hProcess );
		return	FALSE;
	}

	if( ! GetModuleBaseName( hProcess, hModule, szBaseName, dwBaseSize ) ) {
		CloseHandle( hProcess );
		return	FALSE;
	}

	CloseHandle( hProcess );
	return	TRUE;
}

//wID̎qEBhE̎擾
HWND GetDescendantWindow( HWND hWnd, INT nID )
{
	HWND	hWnd2, hWnd3;

	hWnd2 = GetDlgItem( hWnd, nID );
	if( hWnd2 )
		return	hWnd2;

	for( hWnd2=GetWindow(hWnd,GW_CHILD); hWnd2; hWnd2=GetWindow(hWnd2,GW_HWNDNEXT) )
	{
		hWnd3 = GetDescendantWindow( hWnd2, nID );
		if( hWnd3 )
			return	hWnd3;
	}
	return	NULL;
}

//x[XEBhE̎擾
HWND GetBaseWindow( HWND hWnd )
{
	HWND	hWnd2 = hWnd;

	while( GetWindowLong(hWnd2,GWL_STYLE) & WS_CHILD )
		hWnd2 = (HWND)GetWindowLong( hWnd2, GWL_HWNDPARENT );

	return	hWnd2;
}

//g̑傫𓾂
void GetFrameSize( HWND hWnd, SIZE *sz )
{
	DWORD	style = GetWindowLong(hWnd,GWL_STYLE);
	if( (style & WS_THICKFRAME) && !IsIconic(hWnd) )
	{
		sz->cx = GetSystemMetrics(SM_CXSIZEFRAME);
		sz->cy = GetSystemMetrics(SM_CYSIZEFRAME);
	}
	else
	{
		sz->cx = GetSystemMetrics(SM_CXFIXEDFRAME);
		sz->cy = GetSystemMetrics(SM_CYFIXEDFRAME);
	}
}

//^Cgo[̑傫𓾂
void GetCaptionRect( HWND hWnd, RECT *rc )
{
	int		vx, vy;
	DWORD	style = GetWindowLong(hWnd,GWL_STYLE);
	if( (style & WS_THICKFRAME) && !IsIconic(hWnd) )
	{
		vx = GetSystemMetrics(SM_CXSIZEFRAME);
		vy = GetSystemMetrics(SM_CYSIZEFRAME);
	}
	else
	{
		vx = GetSystemMetrics(SM_CXFIXEDFRAME);
		vy = GetSystemMetrics(SM_CYFIXEDFRAME);
	}

	GetWindowRect( hWnd, rc );
	rc->right	-= vx;
	rc->left	+= vx;
	rc->top		+= vy;
	rc->bottom	 = rc->top+GetSystemMetrics(SM_CYCAPTION)-GetSystemMetrics(SM_CYBORDER);
}


//////////////////////////////////////////////////////////
//	_CAO

//zL[R[h̓
VOID SetScanKeyName( HWND hWnd, UINT nVK )
{
	if     ( nVK == VK_LBUTTON )	SetWindowText( hWnd, _T("L Button") );
	else if( nVK == VK_RBUTTON )	SetWindowText( hWnd, _T("R Button") );
	else if( nVK == VK_MBUTTON )	SetWindowText( hWnd, _T("M Button") );
	else if( nVK == VK_PAUSE   )	SetWindowText( hWnd, _T("Pause")    );
	else {
		TCHAR	szBuff[256];
		DWORD	nScan = MapVirtualKey(nVK,0);
		if( ( 0x21<=nVK && nVK<=0x28 )
		||	( 0x2D<=nVK && nVK<=0x2E )
		||	( 0x5B<=nVK && nVK<=0x5D ) )
			nScan += 0x100;

		GetKeyNameText( nScan<<16, szBuff, 256 );
		SetWindowText( hWnd, szBuff );
	}

	SetWindowLong( hWnd, GWL_HINSTANCE, nVK );

	if( nVK != VK_LBUTTON && nVK != VK_SPACE )
		PostMessage( hWnd, BM_SETCHECK, BST_UNCHECKED, 0 );
}
LRESULT CALLBACK KeyScanBtnProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	if( uMsg == BM_SETCHECK && wParam == BST_CHECKED )
		SetWindowText( hWnd, _T("L[") );
	if( uMsg == BM_GETVKEY )
		return	GetWindowLong( hWnd, GWL_HINSTANCE );
	if( uMsg == BM_SETVKEY ) {
		SetScanKeyName( hWnd, wParam );
		return	0;
	}

	if( CallWindowProc( (WNDPROC)GetWindowLong(hWnd,GWL_USERDATA), hWnd,BM_GETCHECK,0,0 ) == BST_CHECKED )
	{
		switch( uMsg )
		{
		case WM_GETDLGCODE:
			return	DLGC_WANTALLKEYS;

		case WM_KEYDOWN:
		case WM_SYSKEYDOWN:
			SetScanKeyName( hWnd, wParam );		break;

		case WM_LBUTTONUP:
			SetScanKeyName( hWnd, VK_LBUTTON );	break;
		case WM_RBUTTONDOWN:
			SetScanKeyName( hWnd, VK_RBUTTON );	break;
		case WM_MBUTTONDOWN:
			SetScanKeyName( hWnd, VK_MBUTTON );	break;
		}
	}

	return	CallWindowProc( (WNDPROC)GetWindowLong(hWnd,GWL_USERDATA), hWnd,uMsg,wParam,lParam );
}
VOID InitKeyScanButton( HWND hWnd )
{
	LONG	n = SetWindowLong( hWnd, GWL_WNDPROC, (LONG)KeyScanBtnProc );
	SetWindowLong( hWnd, GWL_USERDATA, n );
}


//////////////////////////////////////////////////////////
//	ʃ_CAO

//uOtĕۑv_CAO
VOID OFNHookChgExt( LPTSTR szFile, LONG nIndex, OFNOTIFY* pon )
{
	LPCTSTR	lpIndex, lpExt;
	TCHAR	szMask[MAX_PATH];
	BOOL	bChg;
	LONG	n;

	lpIndex = pon->lpOFN->lpstrFilter;
	for( n = nIndex*2-1; n > 0; --n )
		while( *lpIndex++ );

	lpExt = lstrrchr( szFile, _T('\\') );
	if( lpExt )	++lpExt;
	else		lpExt = szFile;
	lpExt = lstrrchr( lpExt, _T('.') );
	if( lpExt==NULL ) lpExt = szFile + lstrlen(szFile);

	bChg = TRUE;
	while( *lpIndex ){
		while( *lpIndex != _T('.') && *lpIndex != _T(';') && *lpIndex != _T('\0') )
			++lpIndex;
		n = 0;
		while( *lpIndex != _T(';') && *lpIndex != _T('\0') )
			szMask[n++] = *lpIndex++;
		if( *lpIndex == _T(';') )	++lpIndex;
		szMask[n] = 0;

		if( lstrchki(lpExt,szMask) == 0 )	bChg = FALSE;
	}

	lstrcpyn( (LPTSTR)pon->lpOFN->lpstrDefExt, szMask+1, 6 );

	if( bChg && *szFile )
		lstrcpy( (LPTSTR)lpExt, szMask );
}
UINT APIENTRY OFNHookProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg )
	{
	case WM_NOTIFY:	{
		OFNOTIFY* pon=(OFNOTIFY*)lParam;
		if( pon->hdr.code == CDN_INITDONE )
			OFNHookChgExt( pon->lpOFN->lpstrFile, pon->lpOFN->nFilterIndex, pon );
		else if( pon->hdr.code == CDN_TYPECHANGE )
		{
			HWND	hCrtl = pon->hdr.hwndFrom;
			TCHAR	szFile[MAX_PATH];
			LONG	nIndex;

			//gq̕ύX
			nIndex = SendDlgItemMessage( hCrtl, cmb1, CB_GETCURSEL, 0, 0 );
			GetDlgItemText( hCrtl, edt1, szFile, MAX_PATH );
			OFNHookChgExt( szFile, nIndex+1, pon );
			SetDlgItemText( hCrtl, edt1, szFile );
		}

		return	TRUE;
	}
	default:
		return	FALSE;
	}
}
DWORD SaveDialogBox( LPTSTR szFile, LPCTSTR szFilter )
{
	OPENFILENAME	ofn;
	TCHAR			szExt[8];

	ZeroMemory( &ofn, sizeof(OPENFILENAME) );
	ofn.lStructSize		= sizeof(OPENFILENAME);
	ofn.hwndOwner		= GetActiveWindow();
	ofn.lpstrFilter		= szFilter;
	ofn.nFilterIndex	= 1;
	ofn.lpstrFile		= szFile;
	ofn.nMaxFile		= MAX_PATH;
	ofn.lpstrDefExt     = szExt;
	ofn.lpfnHook		= OFNHookProc;
	ofn.Flags			= OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY|OFN_NOCHANGEDIR|OFN_ENABLEHOOK|OFN_EXPLORER|OFN_ENABLESIZING;

	if( GetSaveFileName( &ofn ) )
		return	ofn.nFilterIndex;
	else
		return	0;
}

//ut@CJv_CAO
DWORD OpenDialogBox( LPTSTR szFile, LPCTSTR szFilter )
{
	OPENFILENAME	ofn;

	ZeroMemory( &ofn, sizeof(OPENFILENAME) );
	ofn.lStructSize		= sizeof(OPENFILENAME);
	ofn.hwndOwner		= GetActiveWindow();
	ofn.lpstrFilter		= szFilter;
	ofn.nFilterIndex	= 1;
	ofn.lpstrFile		= szFile;
	ofn.nMaxFile		= MAX_PATH;
	ofn.Flags			= OFN_HIDEREADONLY|OFN_NOCHANGEDIR|OFN_FILEMUSTEXIST|OFN_EXPLORER;

	if( GetOpenFileName( &ofn ) )
		return	ofn.nFilterIndex;
	else
		return	0;
}

//uACR̕ύXv_CAO
typedef LONG (CALLBACK *SHCHANGEICONDIALOG) (HWND,LPCWSTR,LONG,int*);
BOOL IconDialogBox( LPTSTR szFile, INT *lpIndex )
{
	HINSTANCE			hShellDll = LoadLibrary( _T("SHELL32.DLL") );
	SHCHANGEICONDIALOG	SHChangeIconDialog = (SHCHANGEICONDIALOG)GetProcAddress( hShellDll, (LPCSTR)62 );
	BOOL				bRet;
#if UNICODE
	bRet = SHChangeIconDialog( GetActiveWindow(), szFile, MAX_PATH, lpIndex );
#else
	{
		WCHAR	szFileW[MAX_PATH];
		MultiByteToWideChar( CP_ACP, 0, szFile, -1, szFileW, MAX_PATH );
		bRet = SHChangeIconDialog( GetActiveWindow(), szFileW, MAX_PATH, lpIndex );
		WideCharToMultiByte( CP_ACP, 0, szFileW, -1, szFile, MAX_PATH, NULL, NULL );
	}
#endif
	FreeLibrary( hShellDll );
	return( bRet );
}

//utH_̎QƁv_CAO
int CALLBACK BrowseCallbackProc( HWND hDlg, UINT uMsg, LPARAM lParam, LPARAM lpData )
{
	switch( uMsg )
	{
	case BFFM_INITIALIZED:
		SendMessage( hDlg, BFFM_SETSELECTION, TRUE, lpData );
		break;
	}

	return	0;
}
BOOL FolderDialogBox( LPTSTR szPath, LPCTSTR szTitle )
{
    BROWSEINFO	bi;
	ITEMIDLIST	*idl;

	bi.hwndOwner		= GetActiveWindow();
	bi.pidlRoot			= NULL;
	bi.pszDisplayName	= szPath;
	bi.lpszTitle		= szTitle;
	bi.ulFlags			= BIF_RETURNONLYFSDIRS;
	bi.lpfn				= BrowseCallbackProc;
	bi.lParam			= (LPARAM)szPath;
	bi.iImage			= 0;
	idl = SHBrowseForFolder( &bi );
	if( idl == NULL )
		return	FALSE;

	SHGetPathFromIDList( idl, szPath );
	CoTaskMemFree( idl );

	return	TRUE;
}


//////////////////////////////////////////////////////////
//	̑

//rbg}bv̕ǂݍ
HBITMAP LoadClippedBitmap( HINSTANCE hInst, LPCTSTR lpID, RECT rc )
{
	INT			nWidth	= rc.right  - rc.left + 1;
	INT			nHeight	= rc.bottom - rc.top  + 1;

	HDC			hSrcDc	= CreateCompatibleDC( NULL );
	HBITMAP		hSrcBmp	= LoadBitmap( hInst, lpID );
	HBITMAP*	pSrcBmp	= (HBITMAP *)SelectObject( hSrcDc, hSrcBmp );

	HDC			hDstDc	= CreateCompatibleDC( NULL );
	HBITMAP		hDstBmp	= CreateCompatibleBitmap( hSrcDc, nWidth, nHeight );
	HBITMAP*	pDstBmp	= (HBITMAP *)SelectObject( hDstDc, hDstBmp );

	BitBlt( hDstDc, 0,0, nWidth,nHeight, hSrcDc, rc.left, rc.top, SRCCOPY );

	SelectObject( hDstDc, pDstBmp );
	DeleteDC( hDstDc );

	SelectObject( hSrcDc, pSrcBmp );
	DeleteObject( hSrcBmp );
	DeleteDC( hSrcDc );

	return	hDstBmp;
}

//t@CPsǂݍ
BOOL ReadFileLine( HANDLE hFile, LPTSTR szBuff, DWORD dwSize, LPDWORD lpSize )
{
	DWORD	i;

	if( ! ReadFile( hFile, szBuff, dwSize, lpSize, NULL ) )
		return	FALSE;

	for( i=0; i < *lpSize && szBuff[i] != '\r' && szBuff[i] != '\n'; ++i )
		;
	if( i < *lpSize && szBuff[i] == '\r' && szBuff[i+1] == '\n' )
		++i;
	if( i < *lpSize )
		++i;

	SetFilePointer( hFile, i*sizeof(TCHAR) - (*lpSize), NULL, FILE_CURRENT );
	szBuff[i] = 0;
	*lpSize = i;

	return	TRUE;
}

//tH_̍쐬
BOOL ForceCreateDirectory( LPCTSTR szPath, LPSECURITY_ATTRIBUTES lpSA )
{
	DWORD	dwAttr;
	TCHAR	szNewPath[MAX_PATH], *p;

	dwAttr = GetFileAttributes( szPath );
	if( dwAttr != 0xFFFFFFFF )
		return( dwAttr & FILE_ATTRIBUTE_DIRECTORY ? TRUE : FALSE );

	lstrcpy( szNewPath, szPath );
	p = lstrrchr( szNewPath, _T('\\') );
	if( p == NULL )
		return	FALSE;

	*p = 0;
	ForceCreateDirectory( szNewPath , lpSA );

	return	CreateDirectory( szPath , lpSA );
}
//tH_̍폜
BOOL ForceRemoveDirectory( LPCTSTR szPath )
{
	TCHAR			szFile[MAX_PATH];
	HANDLE			hFirst;
	WIN32_FIND_DATA	w32fd;

	//TutH_̌
	wsprintf( szFile, _T("%s\\*.*"), szPath );
	hFirst = FindFirstFile( szFile, &w32fd );
	if( hFirst != INVALID_HANDLE_VALUE )
	{
		do {
			if( lstrcmp(w32fd.cFileName, _T("." )) != 0
			&&	lstrcmp(w32fd.cFileName, _T("..")) != 0 )
			{
				wsprintf( szFile, _T("%s\\%s"), szPath, w32fd.cFileName );
				if( w32fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {
					ForceRemoveDirectory( szFile );
				} else {
					DeleteFile( szFile );
				}
			}
		}
		while( FindNextFile(hFirst, &w32fd) );
	}
    FindClose( hFirst );

	return	RemoveDirectory( szPath );
}

//̊J
DWORD FreeMemory( void )
{
	DWORD	i;
	DWORD	dwPIDs[2048];
	DWORD	dwSize;
	HANDLE	hProcess;

	EnumProcesses( dwPIDs, sizeof(dwPIDs), &dwSize );
	dwSize /= sizeof(DWORD);

	for( i=0; i<dwSize; ++i )
	{
		hProcess = OpenProcess( PROCESS_ALL_ACCESS, FALSE, dwPIDs[i] );
		if( hProcess )
		{
			SetProcessWorkingSetSize( hProcess, -1, -1 );
			CloseHandle( hProcess );
		}
	}

	return	dwSize;
}

//bZ[W̎s
BOOL ProcessMessage( HWND hWnd, UINT wMsgMin, UINT wMsgMax )
{
	MSG		msg;

	if( ! PeekMessage(&msg,hWnd,wMsgMin,wMsgMax,PM_REMOVE) )
		return	FALSE;

	TranslateMessage( &msg );
	DispatchMessage( &msg );
	return	TRUE;
}


#ifdef __cplusplus
}	//extern "C"
#endif
